#include <algorithm>
#include <vector>
#include <cstdlib>
#include <cstdio>
#include <cmath>

#define RND(MIN, MAX) ((rand() % 2)? (MIN + rand() % (MAX - MIN + 1)): (MAX - rand() % (MAX - MIN + 1)))
#define MIN_VALUE (-1000000)
#define MAX_VALUE (+1000000)
#define RAD_VALUE ((MAX_VALUE - MIN_VALUE) / 2)
#define EPS (10)

int main(int argc, char *argv[]) {

	char var0 = (argv[1][0]), var1 = (argv[1][1]), var2 = (argv[1][2]); long num = atol(argv[2]), tid = atol(argv[3]), rnd = atol(argv[4]);
	std::vector<long> X(num), Y(num), Z(num), I(num);
	long *DAT[3];
	DAT[0] = ((var0 == 'x')? (X.data()): ((var0 == 'y')? (Y.data()): (Z.data())));
	DAT[1] = ((var1 == 'x')? (X.data()): ((var1 == 'y')? (Y.data()): (Z.data())));
	DAT[2] = ((var2 == 'x')? (X.data()): ((var2 == 'y')? (Y.data()): (Z.data())));
	for (long i = 0; i < num; ++ i) I[i] = i;
	srand(rnd);
	long LIM[2] = {MIN_VALUE, MAX_VALUE};
	long s, t, nm1, nm2, nm3;

	switch (tid) {
	case 9:
		//Все точки лежат на поверхности сферы (в метрике "городских кварталов") с центром в начале координат:
		for (long k = 0; k < num; ++ k) {
			long dis = 0; for (long l = 0; l < 3; ++ l) dis += (DAT[l][k] = RND(0, RAD_VALUE / 3));
			if ((dis = RAD_VALUE - dis) > 0) DAT[rand() % 3][k] += dis;
			for (long l = 0; l < 3; ++ l) {
				DAT[l][k] *= ((rand() % 2)? (+1): (-1));
			}
		}
		break;
	case 8:
		//Все точки лежат на гранях параллелепипеда и достаточно удалены друг от друга:
		for (long nm1 = num / 6, k = 0, l = 0; l < 6; ++ l) {
			if (l == 5) nm1 = num - 5 * nm1; nm2 = sqrt(nm1); while (nm2 * nm2 < nm1) ++ nm2;
			long l0 = l / 2, l1 = (l0 + 1) % 3, l2 = (l1 + 1) % 3, a = l % 2;
			s = (MAX_VALUE - MIN_VALUE - 4 * EPS) / (nm2 - 1); t = MIN_VALUE + EPS;
			for (long i1 = 0; i1 < nm2; ++ i1)
			for (long i2 = 0; (i2 < nm2) && (k < num); ++ i2, ++ k) {
				DAT[l2][k] = t + i1 * s + (2 * EPS - rand() % EPS);
				DAT[l1][k] = t + i2 * s + (2 * EPS - rand() % EPS);
				DAT[l0][k] = LIM[a];
			}
		}
		break;
	case 7:
		//Все точки лежат на ребрах параллелепипеда и достаточно удалены друг от друга:
		for (long nm1 = num / 12, k = 0, l = 0; l < 12; ++ l) {
			long l0 = l / 4, l1 = (l0 + 1) % 3, l2 = (l1 + 1) % 3, a = (l / 2) % 2, b = l % 2;
			if (l == 11) nm1 = num - 11 * nm1;
			s = (MAX_VALUE - MIN_VALUE - 4 * EPS) / (nm1 - 1); t = MIN_VALUE + EPS;
			for (long i1 = 0; i1 < nm1; ++ i1, ++ k) {
				DAT[l0][k] = t + i1 * s + (2 * EPS - rand() % EPS);
				DAT[l1][k] = LIM[a];
				DAT[l2][k] = LIM[b];
			}
		}
		break;
	case 6:
		//Большая часть точек лежит в координатной плоскости и вдоль ее нормали:
		nm1 = num / 2; nm2 = sqrt(nm1); while (nm2 * nm2 < nm1) ++ nm2;
		s = (MAX_VALUE - MIN_VALUE - 4 * EPS) / (nm2 - 1); t = MIN_VALUE + EPS;
		for (long k = 0, i1 = 0; i1 < nm2; ++ i1)
		for (long i2 = 0; (i2 < nm2) && (k < nm1); ++ i2, ++ k) {
			DAT[0][k] = t + i1 * s + (2 * EPS - rand() % EPS);
			DAT[1][k] = t + i2 * s + (2 * EPS - rand() % EPS);
			DAT[2][k] = t;
		}
		nm2 = num - nm1;
		s = (MAX_VALUE - MIN_VALUE - 4 * EPS) / (nm2 - 1); t = MIN_VALUE + EPS;
		for (long k = nm1, i = 0; k < num; ++ i, ++ k) {
			DAT[2][k] = t + i * s + (2 * EPS - rand() % EPS);
			DAT[1][k] = DAT[0][k] = EPS;
		}
		break;
	case 5:
		//Все точки равномерно распределены по узлам трехмерной регулярной сетки:
		nm1 = cbrt(num); while (nm1 * nm1 * nm1 < num) ++ nm1;
		s = (MAX_VALUE - MIN_VALUE - 4 * EPS) / (nm1 - 1); t = MIN_VALUE + EPS;
		for (long k = 0, i1 = 0; i1 < nm1; ++ i1)
		for (long i2 = 0; (i2 < nm1); ++ i2)
		for (long i3 = 0; (i3 < nm1) && (k < num); ++ i3, ++ k) {
			DAT[0][k] = t + i1 * s + (2 * EPS - rand() % EPS);
			DAT[1][k] = t + i2 * s + (2 * EPS - rand() % EPS);
			DAT[2][k] = t + i3 * s + (2 * EPS - rand() % EPS);
		}
		break;
	case 4:
		//Все точки лежат в одной из координатных плоскостей:
		nm1 = sqrt(num); while (nm1 * nm1 < num) ++ nm1;
		s = (MAX_VALUE - MIN_VALUE - 4 * EPS) / (nm1 - 1); t = MIN_VALUE + EPS;
		for (long k = 0, i1 = 0; i1 < nm1; ++ i1)
		for (long i2 = 0; (i2 < nm1) && (k < num); ++ i2, ++ k) {
			DAT[0][k] = t + i1 * s + (2 * EPS - rand() % EPS);
			DAT[1][k] = t + i2 * s + (2 * EPS - rand() % EPS);
			DAT[2][k] = t;
		}
		break;
	case 3:
		//Все точки лежат вдоль одной из осей координат:
		s = (MAX_VALUE - MIN_VALUE - 4 * EPS) / (num - 1); t = MIN_VALUE + EPS;
		for (long k = 0; k < num; ++ k) {
			DAT[0][k] = t + k * s + (2 * EPS - rand() % EPS);
			DAT[1][k] = MIN_VALUE; DAT[2][k] = MAX_VALUE;
		}
		break;
	case 2:
		//Все точки лежат по диагонали:
		s = (MAX_VALUE - MIN_VALUE - 4 * EPS) / (num - 1); t = MIN_VALUE + EPS;
		for (long k = 0; k < num; ++ k) {
			DAT[0][k] = t + k * s + (2 * EPS - rand() % EPS);
			DAT[1][k] = DAT[0][k]; DAT[2][k] = DAT[1][k];
		}
		break;
	case 1:
		//Большая часть точек имеет одинаковые координаты:
		for (long k = 0; k < num; ++ k) {
			DAT[0][k] = RND(MIN_VALUE, MAX_VALUE);
			DAT[1][k] = RND(MIN_VALUE, MAX_VALUE);
			DAT[2][k] = RND(MIN_VALUE, MAX_VALUE);
		}
		for (long k = (2 * num) / 3; k >= 0; -- k) {
			DAT[0][k] = DAT[0][0];
			DAT[1][k] = DAT[1][0];
			DAT[2][k] = DAT[2][0];
		}
		break;
	case 0:
		//Случайный тест:
		for (long k = 0; k < num; ++ k) {
			DAT[0][k] = RND(MIN_VALUE, MAX_VALUE);
			DAT[1][k] = RND(MIN_VALUE, MAX_VALUE);
			DAT[2][k] = RND(MIN_VALUE, MAX_VALUE);
		}
		break;
	}
	std::random_shuffle(I.begin(), I.end());

	FILE *fid = fopen("input.txt", "wt");
	fprintf(fid, "%lu\n", num);
	for (long i = 0; i < num; ++ i) {
		fprintf(fid, "%li ", X[I[i]]);
		fprintf(fid, "%li ", Y[I[i]]);
		fprintf(fid, "%li ", Z[I[i]]);
		fprintf(fid, "\n");
	}
	fclose(fid);

	return 0;
}
