#include <algorithm>
#include <cstdio>

#define MAX_NUM (50000)

static long DATX[MAX_NUM], DATY[MAX_NUM]; static long INDX[MAX_NUM];

inline long dis(long a, long b) { return std::abs(DATX[a] - DATX[b]) + std::abs(DATY[a] - DATY[b]); }

long get_min_dis(long IND[], long num) {
	//...
	if (num == 1) return -1; else if (num == 2) {
		if (DATY[IND[0]] > DATY[IND[1]]) std::swap(IND[0], IND[1]); return dis(IND[0], IND[1]);
	}
	//Разбиваем множество точек гиперплоскостью, проходящей через его медиану:
	long k, l, r = num >> 1, *IL = IND, *IR = IND + r, nl = r, nr = num - r, mid = DATX[IND[r]];
	long dl = get_min_dis(IL, nl), dr = get_min_dis(IR, nr);
	long d0;
	if ((dl == -1) || (dr == -1))
		d0 = std::max(dl, dr);
	else {
		d0 = std::min(dl, dr);
	}
	if (d0 == 0) return 0;
	//Выполняем слияние ответов:
	static long T0[MAX_NUM];
	long *TR = T0 + nl;
	long *TL = T0;
	for (l = 0, k = 0; k < nl; ++ k) if (std::abs(DATX[IL[k]] - mid) <= d0) TL[l ++] = IL[k];
	long ml = l;
	for (r = 0, k = 0; k < nr; ++ k) if (std::abs(DATX[IR[k]] - mid) <= d0) TR[r ++] = IR[k];
	long mr = r;
	for (l = 0, r = 0; r < mr; ++ r) {
		while ((l < ml) && (DATY[TL[l]] <  DATY[TR[r]] - d0)) ++ l;
		k = l;
		while ((k < ml) && (DATY[TL[k]] <= DATY[TR[r]] + d0)) {
			d0 = std::min(d0, dis(TL[k], TR[r]));
			++ k;
		}
	}
	std::merge(IL, IL + nl, IR, IR + nr, T0, [](long a, long b) {
		return DATY[a] < DATY[b];
	});
	std::copy(T0, T0 + nl + nr, IND);
	//...
	return d0;
}

int main() {
	long num, ans;
	FILE *fid = fopen("input.txt", "rt"); fscanf(fid, "%li", &num);
	for (long i = 0; i < num; INDX[i] = i ++) {
		fscanf(fid, "%li %li %*i", &DATX[i], &DATY[i]);
	}
	fclose(fid);
	//Предварительная сортировка:
	std::sort(INDX, INDX + num, [](long a, long b) {
		return DATX[a] < DATX[b];
	});
	ans = (get_min_dis(INDX, num) + 1) / 2;
	//...
	fid = fopen("output.txt", "wt");
	fprintf(fid, "%li\n", ans);
	fclose(fid);
	//...
	return 0;
}
